import net.sf.flashlib.util.Delegate;

import net.sf.emff.EMFF;
import net.sf.emff.UpdateUtil;

import net.sf.emff.configuration.ConfigurationFlashVars;



/**
 * The "old" skin.
 * 
 * @version  0.0.1
 * @author   Marc Reichelt
 */
class Skin {
	
	private static var skin : Skin = null;
	
	private var emff : EMFF = null;
	private var beginMC : MovieClip = null;
	private var stopMC : MovieClip = null;
	private var playMC : MovieClip = null;
	private var loadprogressMC : MovieClip = null;
	private var playprogressMC : MovieClip = null;
	
	
	/**
	 * Main method that simply creates a new skin.
	 */
	public static function main() : Void {
		
		if (UpdateUtil.getInstance().updateNeeded()) {
			return;
		}
		
		skin = new Skin();
	}
	
	/**
	 * Initialization of this skin.
	 */
	private function Skin() {
		// read configuration and create new player
		emff = new EMFF( new ConfigurationFlashVars() );
		
		// save 
		beginMC = _root.beginMC;
		stopMC = _root.stopMC;
		playMC = _root.playMC;
		loadprogressMC = _root.loadprogressMC;
		playprogressMC = _root.playprogressMC;
		
		var emff : EMFF = this.emff;
		// set actions
		beginMC.onRelease = function () : Void {
			emff.setActiveIndex(0);
			emff.play();
		}
		stopMC.onRelease = Delegate.create(emff, emff.stop);
		playMC.onRelease = Delegate.create(emff, emff.play);
		
		// init width of progress bars
		loadprogressMC._width = 0;
		playprogressMC._width = 0;
		
		_root.onEnterFrame = Delegate.create(this, enterFrame);
		
	}
	
	/**
	 * Method that is activated every frame and will refresh the visualisation.
	 */
	private function enterFrame() : Void {
		loadprogressMC._width = emff.getLoadingProgress() * 90;
		playprogressMC._width = emff.getPlayingProgress() * 90;
	}
	
}
